unit VaxChat;

interface

uses
    VaxServerCOM,
    VaxServerExCOM;

type TVaxChat = class

private

var


    public

      procedure OnChatMessageText(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; sMsgText: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
      procedure OnChatMessageTyping(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; bIsTypingStart: Boolean; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
      procedure OnChatStatusSubscribe(nSubscrbId: Integer; sMsgFrom: String; sMsgTo: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);

      procedure OnChatMessageSuccess(nChatMsgId: Integer);
      procedure OnChatMessageFailed(nChatMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String);
      procedure OnChatMessageTimeout(nChatMsgId: Integer);

    public
      constructor Create();


end;

implementation

var bResult : Boolean;

      constructor TVaxChat.Create();
      begin
           //
      end;

      procedure TVaxChat.OnChatMessageText(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; sMsgText: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
      begin
            bResult := TVaxServerExCOM.mVaxExCOM.AcceptChatMessage(nChatMsgId, TVaxServerCOM.VAX_PEER_TYPE_USER, sMsgTo);
      end;

      procedure TVaxChat.OnChatMessageTyping(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; bIsTypingStart: Boolean; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
      begin
            bResult := TVaxServerExCOM.mVaxExCOM.AcceptChatMessage(nChatMsgId, TVaxServerCOM.VAX_PEER_TYPE_USER, sMsgTo);
      end;

      procedure TVaxChat.OnChatStatusSubscribe(nSubscrbId: Integer; sMsgFrom: String; sMsgTo: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
      begin
            bResult := TVaxServerExCOM.mVaxExCOM.AcceptChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo, TVaxServerCOM.VAX_PEER_TYPE_USER, sMsgTo);
      end;

      procedure TVaxChat.OnChatMessageSuccess(nChatMsgId: Integer);
      begin
        //
      end;

      procedure TVaxChat.OnChatMessageFailed(nChatMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String);
      begin
        //
      end;

      procedure TVaxChat.OnChatMessageTimeout(nChatMsgId: Integer);
      begin
        //
      end;


end.
