﻿Public Class QueueForm

    Private m_objVaxTeleSIP As cVaxServerSIP

    Public Sub New(ByRef objVaxTeleSIP As cVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP

    End Sub

    Private Sub BtnAddQueue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddQueue.Click

        If (comboQueueName.Text = "" Or comboProcessMode.Text = "") Then
            MessageBox.Show("Please fill all fields.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If comboQueueName.FindStringExact(comboQueueName.Text) <> -1 Then
            If (MessageBox.Show("Queue already exist, do you want to continue?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.No) Then
                Exit Sub
            End If
        End If

        If (comboQueueName.Items.Contains(comboQueueName.Text)) Then
            m_objVaxTeleSIP.RemoveQueue(comboQueueName.Text)
        End If

        If (Not m_objVaxTeleSIP.AddQueue(comboQueueName.Text, EditQueueMusicFile.Text, EditQueueDialTone.Text)) Then
            MessageBox.Show("Queue couldn't be added.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        For Each sUserName As String In ListBoxLogin.Items
            m_objVaxTeleSIP.AddQueueAgent(comboQueueName.Text, sUserName)
        Next

        If (Not comboQueueName.Items.Contains(comboQueueName.Text)) Then
            comboQueueName.Items.Add(comboQueueName.Text)
        End If

        '///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        Dim nProcessMode As Integer = GetProcessMode()
        If (nProcessMode = -1) Then Return

        Dim nProcessType As Integer = GetProcessType()
        If (nProcessType = -1) Then Return

        '///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        m_objVaxTeleSIP.SetQueueProcessMode(comboQueueName.Text, nProcessMode, nProcessType)

        MessageBox.Show("Queue added/updated successfully.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnRemoveQueue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveQueue.Click

        If (comboQueueName.Text = "" Or (Not comboQueueName.Items.Contains(comboQueueName.Text))) Then
            Return
        End If

        Dim nIndex As Integer = comboQueueName.FindStringExact(comboQueueName.Text)
        If (nIndex = -1) Then Return

        m_objVaxTeleSIP.RemoveQueue(comboQueueName.Text)
        comboQueueName.Items.RemoveAt(nIndex)

        ClearDlgContent()

        If (comboQueueName.Items.Count > 0) Then
            comboQueueName.SelectedIndex = 0
        End If

        ShowQueueDetails()

        MessageBox.Show("Queue removed successfully.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnQueueClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnQueueClear.Click

        comboQueueName.Text = ""

        comboProcessMode.Text = ""
        comboProcessType.Text = ""

        EditQueueMusicFile.Text = ""
        EditQueueDialTone.Text = ""

        comboAgentName.Text = ""
        ListBoxLogin.Items.Clear()

    End Sub

    Private Sub BtnAddQueueAgent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddQueueAgent.Click

        If ListBoxLogin.FindStringExact(comboAgentName.Text) <> -1 Then
            MessageBox.Show("Agent already exists.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        ListBoxLogin.Items.Add(comboAgentName.Text)

    End Sub

    Private Sub BtnRemoveQueueAgent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveQueueAgent.Click

        ListBoxLogin.Items.Remove(ListBoxLogin.SelectedItem)

    End Sub

    Private Sub BtnClearQueueAgent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearQueueAgent.Click

        ListBoxLogin.Items.Clear()

    End Sub

    Private Sub ClearDlgContent()

        comboQueueName.Text = ""
        comboProcessMode.Text = ""
        comboProcessType.Text = ""

        ListBoxLogin.Items.Clear()

    End Sub

    Private Function GetProcessMode()

        If (comboProcessMode.SelectedIndex = -1) Then
            MessageBox.Show("Please select a process mode.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Return comboProcessMode.SelectedIndex

    End Function

    Private Function GetProcessType()

        If (comboProcessType.SelectedIndex = -1) Then
            MessageBox.Show("Please select a process type.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Return comboProcessType.SelectedIndex

    End Function

    Private Sub AddProcessMode()

        comboProcessMode.Items.Clear()

        comboProcessMode.Items.Add(cDefine.USER_ALGO_HUNT_RANDOM)
        comboProcessMode.Items.Add(cDefine.USER_ALGO_LEAST_ANSWERED)
        comboProcessMode.Items.Add(cDefine.USER_ALGO_LEAST_TALK_TIME)
        comboProcessMode.Items.Add(cDefine.USER_ALGO_LONGEST_WAITING)
        comboProcessMode.Items.Add(cDefine.USER_ALGO_PRIORITIZED_HUNT)
        comboProcessMode.Items.Add(cDefine.USER_ALGO_ROUND_ROBIN)
        comboProcessMode.Items.Add(cDefine.USER_ALGO_RING_ALL)

        If (comboProcessMode.Items.Count > 0) Then
            comboProcessMode.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddProcessType()

        comboProcessType.Items.Clear()

        comboProcessType.Items.Add(cDefine.ALGO_TYPE_FREE)
        comboProcessType.Items.Add(cDefine.ALGO_TYPE_ANY)

        If (comboProcessType.Items.Count > 0) Then
            comboProcessType.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddUsers()

        comboAgentName.Items.Clear()

        Dim objUserList As ArrayList = New ArrayList()

        m_objVaxTeleSIP.GetUserNameAll(objUserList)

        If (objUserList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objUserList.Count - 1
            comboAgentName.Items.Add(objUserList.Item(nIndex))
        Next

        If (comboAgentName.Items.Count > 0) Then
            comboAgentName.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddQueues()

        comboQueueName.Items.Clear()

        Dim objListQueueName As List(Of String) = New List(Of String)
        m_objVaxTeleSIP.GetQueueNameAll(objListQueueName)

        If (objListQueueName.Count <= 0) Then
            Return
        End If

        For Each sQueueName In objListQueueName
            comboQueueName.Items.Add(sQueueName)
        Next

        If (comboQueueName.Items.Count > 0) Then
            comboQueueName.SelectedIndex = 0
        End If

    End Sub

    Public Sub OnSetActive()

        AddProcessMode()
        AddProcessType()
        AddUsers()
        AddQueues()

        ShowQueueDetails()

    End Sub

    Private Sub ShowQueueDetails()

        Dim sQueueName As String = comboQueueName.Text
        If (sQueueName.Length = 0) Then Return

        ListBoxLogin.Items.Clear()

        Dim nProcessMode As Integer = -1
        Dim nProcessType As Integer = -1
        Dim objUserNameList As List(Of String) = New List(Of String)

        Dim sQueueMusicFile As String = "", sQueueDialToneFile = ""

        If (Not m_objVaxTeleSIP.GetQueueDetails(comboQueueName.Text, nProcessMode, nProcessType, objUserNameList, sQueueMusicFile, sQueueDialToneFile)) Then Return

        comboProcessMode.SelectedIndex = nProcessMode
        comboProcessType.SelectedIndex = nProcessType

        EditQueueMusicFile.Text = sQueueMusicFile
        EditQueueDialToneFile.Text = sQueueDialToneFile

        For Each sMemberName In objUserNameList
            ListBoxLogin.Items.Add(sMemberName)
        Next

    End Sub

    Private Sub comboQueueNameSelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboQueueName.SelectedIndexChanged
        ShowQueueDetails()
    End Sub

End Class

