﻿Class cQueueDetails

    Public m_nQueueMusicId As Integer
    Public m_nQueueDialToneId As Integer

    Public m_sQueueName As String

    Public m_sQueueMusicFile As String
    Public m_sQueueDialToneFile As String

    Public m_sUserName As String

    Public m_nProcessMode As Integer
    Public m_nProcessType As Integer
    Public m_nPriorityWeight As Integer

    Dim m_objQueueUserList As cQueueAgentList

    Public Sub New(ByVal sQueueName As String)

        m_sQueueName = sQueueName

        m_nQueueMusicId = -1
        m_nProcessMode = -1
        m_nProcessType = -1

        m_objQueueUserList = New cQueueAgentList()

    End Sub

    Public Function AddQueueAgent(ByVal sUserName As String) As Boolean

        Return m_objQueueUserList.AddAgent(sUserName)

    End Function

    Public Function IsAgentExisted(ByVal sUserName As String) As Boolean

        Return m_objQueueUserList.IsAgentExisted(sUserName)

    End Function

    Public Function GetQueueAgentList(ByRef objListUserName As List(Of String)) As Boolean

        For index As Integer = 0 To m_objQueueUserList.GetQueueAgentCount() - 1
            objListUserName.Add(m_objQueueUserList.GetQueueAgentAt(index))
        Next

        Return True

    End Function

    Public Sub RemoveQueueAgent(ByVal sUserName As String)

        m_objQueueUserList.RemoveAgent(sUserName)

    End Sub

    Public Function GetQueueAgentAt(ByVal nIndex As Integer) As String

        Return m_objQueueUserList.GetQueueAgentAt(nIndex)

    End Function

    Public Function GetQueueAgentCount() As Integer

        Return m_objQueueUserList.GetQueueAgentCount()

    End Function

    Public Sub DeleteAgentAll()

        m_objQueueUserList.RemoveAll()

    End Sub

End Class

Public Class cQueueList

    Dim m_objQueueDetailsList As New Dictionary(Of String, cQueueDetails)

    Public Function AddQueue(ByVal sQueueName As String, ByVal sQueueMusicFile As String, ByVal nQueueMusicId As Integer, ByVal sQueueDialToneFile As String, ByVal nQueueDialToneId As Integer) As Boolean

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)

        If (objQueueDetails Is Nothing) Then

            objQueueDetails = New cQueueDetails(sQueueName)
            m_objQueueDetailsList.Add(sQueueName, objQueueDetails)

        End If

        objQueueDetails.m_sQueueName = sQueueName

        objQueueDetails.m_sQueueMusicFile = sQueueMusicFile
        objQueueDetails.m_nQueueMusicId = nQueueMusicId

        objQueueDetails.m_sQueueDialToneFile = sQueueDialToneFile
        objQueueDetails.m_nQueueDialToneId = nQueueDialToneId

        Return True

    End Function

    Public Sub RemoveQueue(ByVal sQueueName As String)

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return

        m_objQueueDetailsList.Remove(sQueueName)

    End Sub

    Public Function AddQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return False

        Return objQueueDetails.AddQueueAgent(sUserName)

    End Function

    Public Sub RemoveQueueAgent(ByVal sQueueName As String, ByVal sUserName As String)

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return

        objQueueDetails.RemoveQueueAgent(sUserName)

    End Sub

    Public Function GetQueueMusicId(ByVal sQueueName As String) As Integer

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return -1

        Return objQueueDetails.m_nQueueMusicId

    End Function

    Public Function GetQueueDialToneId(ByVal sQueueName As String) As Integer

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return -1

        Return objQueueDetails.m_nQueueDialToneId

    End Function

    Public Function GetQueueDetails(ByVal sQueueName As String, ByRef sQueueMusic As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef objListUserName As List(Of String), ByRef sQueueMusicFile As String, ByRef sQueueDialToneFile As String) As Boolean

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return False

        nProcessMode = objQueueDetails.m_nProcessMode
        nProcessType = objQueueDetails.m_nProcessType

        sQueueMusicFile = objQueueDetails.m_sQueueMusicFile
        sQueueDialToneFile = objQueueDetails.m_sQueueDialToneFile

        Return objQueueDetails.GetQueueAgentList(objListUserName)

    End Function

    Public Sub SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return

        objQueueDetails.m_sQueueName = sQueueName
        objQueueDetails.m_nProcessMode = nProcessMode
        objQueueDetails.m_nProcessType = nProcessType

    End Sub

    Public Overloads Sub SetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByVal nPriorityWeight As Integer)

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return

        objQueueDetails.m_sQueueName = sQueueName
        objQueueDetails.m_sUserName = sUserName
        objQueueDetails.m_nPriorityWeight = nPriorityWeight

    End Sub

    Public Function GetQueueAgentDetails(ByVal sQueueName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef sListQueueUser As List(Of String)) As Boolean

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return False

        sQueueName = objQueueDetails.m_sQueueName
        nProcessMode = objQueueDetails.m_nProcessMode
        nProcessType = objQueueDetails.m_nProcessType

        Return objQueueDetails.GetQueueAgentList(sListQueueUser)

    End Function

    Public Function IsAgentExisted(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return False

        Return objQueueDetails.IsAgentExisted(sUserName)

    End Function

    Public Function GetQueueNameList(ByRef sListQueueName As List(Of String)) As Boolean

        Dim objQueueDetails As cQueueDetails = Nothing

        For Each sQueueName As KeyValuePair(Of String, cQueueDetails) In m_objQueueDetailsList

            objQueueDetails = sQueueName.Value
            sListQueueName.Add(objQueueDetails.m_sQueueName)

        Next

        Return True

    End Function


    Public Function GetQueueAgentAt(ByVal sQueueName As String, ByVal nIndex As Integer) As String

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return False

        Return objQueueDetails.GetQueueAgentAt(nIndex)

    End Function

    Public Function GetQueueAgentCount(ByVal sQueueName As String) As Integer

        Dim objQueueDetails As cQueueDetails = Nothing

        m_objQueueDetailsList.TryGetValue(sQueueName, objQueueDetails)
        If (objQueueDetails Is Nothing) Then Return 0

        Return objQueueDetails.GetQueueAgentCount()

    End Function

    Public Sub DeleteQueueAll()

        For Each objQueueDetails As cQueueDetails In m_objQueueDetailsList.Values

            objQueueDetails.DeleteAgentAll()

        Next

        m_objQueueDetailsList.Clear()

    End Sub


End Class
