#include "stdafx.h"
#include "CallParking.h"

#include"VaxServerExCOM.h"

CCallParking::CCallParking(void)
{
}


CCallParking::~CCallParking(void)
{
}

void CCallParking::OnIncomingCall(LONG lSessionId, LPCTSTR sDialNo, LONG lFromPeerType, BOOL& bProcessed)
{
	bProcessed = FALSE;

	CString sPrefixedDialNo = sDialNo;
	sPrefixedDialNo.Trim();

	if(sPrefixedDialNo.Find("#3#") != 0)
		return;

	bProcessed = TRUE;

	sPrefixedDialNo.Replace("#3#", "");
	sPrefixedDialNo.Trim();

	int nSlotId = atoi(sPrefixedDialNo);

	if(nSlotId == -1)
		return;
	
	if(!CVaxServerExCOM::m_pVaxServerExCOM->ConnectToParkedCall(lSessionId, VAX_CALL_CHANNEL_ZERO, nSlotId))
		return;

	StopMusicCallPark(lSessionId);
}

void CCallParking::OnCallSessionTransferBlind(LONG lTransfererSessionId, LONG lTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo, BOOL& bProcessed)
{
	bProcessed = FALSE;

	int nChannelId = 0;
	BOOL bRes = FALSE;

    if(lTransfererChannelId == 0)
    {
        nChannelId = 1;
    }

	CString sPrefixedSlotId = sTransferTo;
	sPrefixedSlotId.Trim();

	if(sPrefixedSlotId.Find("#2#") != 0)
		return;

	bProcessed = TRUE; 
	
	if(!CVaxServerExCOM::m_pVaxServerExCOM->AcceptTransferBlind(lTransfererSessionId, sTransferee, sTransferee, "", -1, "", 30))
		return;
	
	sPrefixedSlotId.Replace("#2#", "");
	sPrefixedSlotId.Trim();

	int nSlotId = atoi(sPrefixedSlotId);

	if(nSlotId == -1)
		return;

	if(!CVaxServerExCOM::m_pVaxServerExCOM->ParkCallSession(lTransfererSessionId, nChannelId, nSlotId))
		return;

	if(!StartMusicCallPark(lTransfererSessionId, nChannelId))
		return;
}


BOOL CCallParking::StartMusicCallPark(LONG lSessionId, int nChannelId)
{
	LONG lMusicId = CVaxServerExCOM::m_pVaxServerExCOM->GetCallParkMusicId();

	if(lMusicId == -1)
		return FALSE;

	return CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStartToCallSession(lSessionId, nChannelId, lMusicId, TRUE, 10);
}

void CCallParking::StopMusicCallPark(LONG lSessionId)
{
	LONG lMusicId = CVaxServerExCOM::m_pVaxServerExCOM->GetCallParkMusicId();

	if(lMusicId == -1)
		return;

	CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStopToCallSession(lSessionId, VAX_CALL_CHANNEL_ZERO, lMusicId);
	CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStopToCallSession(lSessionId, VAX_CALL_CHANNEL_ONE, lMusicId);
}