#include "StdAfx.h"
#include "StoreLine.h"

#define SUB_KEY_BUFFER_SIZE	2000

#define ROOT_PATH	"Lines\\"

CStoreLine::CStoreLine(void)
{

}

CStoreLine::~CStoreLine(void)
{
}

BOOL CStoreLine::AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sOutboundProxySIP, LPCTSTR sCodecList, BOOL bRegister )
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sLineName);

	CStoreRegistry::SetTEXT(sKeyPath, "LineName", sLineName);
	CStoreRegistry::SetTEXT(sKeyPath, "DisplayName", sDisplayName);
	CStoreRegistry::SetTEXT(sKeyPath, "UserName", sUserName);
	CStoreRegistry::SetTEXT(sKeyPath, "AuthUser", sAuthUser);

	CStoreRegistry::SetTEXT(sKeyPath, "Authpwd", sAuthPwd);
	CStoreRegistry::SetTEXT(sKeyPath, "DomainRealm", sDomainRealm);
	CStoreRegistry::SetTEXT(sKeyPath, "ProxySIP", sProxySIP);

    CStoreRegistry::SetTEXT(sKeyPath, "OutboundproxySIP", sOutboundProxySIP);
	CStoreRegistry::SetTEXT(sKeyPath, "CodecList", sCodecList);
		
	CStoreRegistry::SetBOOL(sKeyPath, "Register", bRegister);
	return TRUE; 
}

void CStoreLine::RemoveLine(LPCTSTR sLineName )
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sLineName);

	CStoreRegistry::DeleteSubKey(sKeyPath);
}


BOOL CStoreLine::GetLine(LPCTSTR sLineName, CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sOutboundProxySIP, CString& sCodecList,BOOL& bRegister )
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sLineName);
	
	CStoreRegistry::GetTEXT(sKeyPath, "LineName", (CString)sLineName);
	CStoreRegistry::GetTEXT(sKeyPath, "DisplayName", sDisplayName);
	CStoreRegistry::GetTEXT(sKeyPath, "UserName", sUserName);
	CStoreRegistry::GetTEXT(sKeyPath, "AuthUser", sAuthUser);

    CStoreRegistry::GetTEXT(sKeyPath, "Authpwd", sAuthPwd);
	CStoreRegistry::GetTEXT(sKeyPath, "DomainRealm", sDomainRealm);
    CStoreRegistry::GetTEXT(sKeyPath, "ProxySIP", sProxySIP);

    CStoreRegistry::GetTEXT(sKeyPath, "OutboundproxySIP", sOutboundProxySIP);
	CStoreRegistry::GetTEXT(sKeyPath, "CodecList", sCodecList);

	CStoreRegistry::GetBOOL(sKeyPath, "Register", bRegister);
	return TRUE; 
}

void CStoreLine::GetLineAll(CStringList* pLineList)
{
	pLineList->RemoveAll();

	 CString sKeyPath;
	 sKeyPath = ROOT_PATH;

	 CStoreRegistry::EnumSubKeys(sKeyPath, pLineList);
}

BOOL CStoreLine::AddLineRoute(LPCTSTR sLineName, int nToPeerType, CString sToPeerName, BOOL bRejected, CString sRoomName, CString sQueueName, CString sRingGroupName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sLineName);

	CStoreRegistry::SetINT(sKeyPath, "ToPeerType", nToPeerType);
	CStoreRegistry::SetTEXT(sKeyPath, "ToPeerName", sToPeerName);

	CStoreRegistry::SetTEXT(sKeyPath, "RoomName", sRoomName);
    CStoreRegistry::SetBOOL(sKeyPath, "Rejected", bRejected);

	CStoreRegistry::SetTEXT(sKeyPath, "QueueName", sQueueName);
	CStoreRegistry::SetTEXT(sKeyPath, "RingGroupName", sRingGroupName);

	return TRUE;
}

BOOL CStoreLine::GetLineRoute(LPCTSTR sLineName,int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sLineName);

	CStoreRegistry::GetINT(sKeyPath, "ToPeerType", nToPeerType);
	CStoreRegistry::GetTEXT(sKeyPath, "ToPeerName", sToPeerName);

	CStoreRegistry::GetTEXT(sKeyPath, "RoomName", sRoomName);
    CStoreRegistry::GetBOOL(sKeyPath, "Rejected", bRejected);

	CStoreRegistry::GetTEXT(sKeyPath, "QueueName", sQueueName);
	CStoreRegistry::GetTEXT(sKeyPath, "RingGroupName", sRingGroupName);

	return TRUE;
}

BOOL CStoreLine::RemoveLineRoute(LPCTSTR sLineName)
{
    CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sLineName);

	CStoreRegistry::DeleteValue(sKeyPath, "ToPeerType");
	CStoreRegistry::DeleteValue(sKeyPath, "Rejected");

	CStoreRegistry::DeleteValue(sKeyPath, "ToPeerName");
	CStoreRegistry::DeleteValue(sKeyPath, "RoomName");

	CStoreRegistry::DeleteValue(sKeyPath, "QueueName");
	CStoreRegistry::DeleteValue(sKeyPath, "RingGroupName");
 
	return TRUE;
}

BOOL CStoreLine::IsDataStored()
{
   return CStoreRegistry::IsKeyExist(ROOT_PATH);
}

