﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreCOMM : cStoreRegistry
    {
        const string COMM_ROOT_PATH = "COMM\\";

        public cStoreCOMM()
        {
        }

        ~cStoreCOMM()
        {
        }

        public Boolean Initialize(string sDomainRealm, string sSIPListenIP, int nSIPListenPort, string sRTPListenIP, int nRTPListenPort)
        {
            string sPath = COMM_ROOT_PATH;

            base.SetTEXT(sPath, "DomainRealm", sDomainRealm);
            base.SetTEXT(sPath, "SIPListenIP", sSIPListenIP);
            base.SetTEXT(sPath, "RTPListenIP", sRTPListenIP);

            base.SetINT(sPath, "SIPListenPort", nSIPListenPort);
            base.SetINT(sPath, "RTPListenPort", nRTPListenPort);

            return true;
        }

        public Boolean GetInitialize(ref string sDomainRealm, ref  string sSIPListenIP, ref  int nSIPListenPort, ref string sRTPListenIP, ref int nRTPListenPort)
        {
            string sPath = COMM_ROOT_PATH;

            base.GetTEXT(sPath, "DomainRealm", ref sDomainRealm);
            base.GetTEXT(sPath, "SIPListenIP", ref sSIPListenIP);
            base.GetTEXT(sPath, "RTPListenIP", ref sRTPListenIP);

            base.GetINT(sPath, "SIPListenPort", ref nSIPListenPort);
            base.GetINT(sPath, "RTPListenPort", ref nRTPListenPort);

            return true;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////

        public bool SetMusicHold(string sFileName)
        {
            string sPath = COMM_ROOT_PATH;

            return base.SetTEXT(sPath, "MusicHold", sFileName);
        }

        public bool GetMusicHold(ref string sFileName)
        {
            string sPath = COMM_ROOT_PATH;
            return base.GetTEXT(sPath, "MusicHold", ref sFileName);
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////////

        public bool SetMusicDialTone(string sFileName)
        {
            string sPath = COMM_ROOT_PATH;
            return base.SetTEXT(sPath, "MusicDialTone", sFileName);
        }

        public bool GetMusicDialTone(ref string sFileName)
        {
            string sPath = COMM_ROOT_PATH;
            return base.GetTEXT(sPath, "MusicDialTone", ref sFileName);
        }

        public bool SetMusicCallParking(string sFileName)
        {
            string sPath = COMM_ROOT_PATH;
            return base.SetTEXT(sPath, "MusicCallParking", sFileName);
        }

        public bool GetMusicCallParking(ref string sFileName)
        {
            string sPath = COMM_ROOT_PATH;
            return base.GetTEXT(sPath, "MusicCallParking", ref sFileName);
        }

        public bool IsDataStored()
        {
            return base.IsKeyExist(COMM_ROOT_PATH);
        }

    }
}
