﻿Imports Microsoft.Win32

Public Class cStoreRegistry

    Private Const REGISTRY_ROOT_PATH = "SOFTWARE\\VaxTeleServerSIP"

    Private m_hKey As RegistryKey

    Public Sub New()

        Open()

    End Sub

    Public Sub Open()

        m_hKey = Registry.CurrentUser.CreateSubKey(REGISTRY_ROOT_PATH)

    End Sub

    Public Sub Close()

        If m_hKey Is Nothing Then
            Return
        End If

        m_hKey.Close()

    End Sub

    ''/////////////////////////////////////////////////////////////////////////////////
    ''/////////////////////////////////////////////////////////////////////////////////

    Private Function CreateKey(ByVal sKey As String) As RegistryKey

        If (sKey.Length = 0) Then
            Return Nothing

        End If

        Return m_hKey.CreateSubKey(sKey)

    End Function

    Private Function OpenKey(ByVal sKey As String, ByVal bWritable As Boolean) As RegistryKey

        If (sKey.Length = 0) Then
            Return Nothing

        End If

        Return m_hKey.OpenSubKey(sKey, bWritable)

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Function SetTEXT(ByVal sKeyName As String, ByVal sValueName As String, ByVal sValueData As String) As Boolean

        If (sKeyName.Length = 0 Or sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey = CreateKey(sKeyName)

        If (hKey Is Nothing) Then
            Return False
        End If

        hKey.SetValue(sValueName, sValueData, RegistryValueKind.String)
        Return True

    End Function

    Public Function SetINT(ByVal sKeyName As String, ByVal sValueName As String, ByVal nValueData As Integer) As Boolean

        If (sKeyName.Length = 0 Or sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey = CreateKey(sKeyName)

        If (hKey Is Nothing) Then
            Return False
        End If

        hKey.SetValue(sValueName, nValueData, RegistryValueKind.DWord)
        Return True
    End Function

    Public Function SetLONG(ByVal sKeyName As String, ByVal sValueName As String, ByVal lValueData As Long) As Boolean

        If (sKeyName.Length = 0 Or sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey = CreateKey(sKeyName)

        If (hKey Is Nothing) Then
            Return False
        End If

        hKey.SetValue(sValueName, lValueData, RegistryValueKind.DWord)
        Return True
    End Function

    Public Function SetBOOL(ByVal sKeyName As String, ByVal sValueName As String, ByVal bValueData As Boolean) As Boolean

        Dim nVlaueData As Integer = 0

        If (bValueData = True) Then
            nVlaueData = 1
        End If

        Return SetINT(sKeyName, sValueName, nVlaueData)
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Function GetTEXT(ByVal sKeyName As String, ByVal sValueName As String, ByRef sValueData As String) As Boolean

        If (sKeyName.Length = 0 Or sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey = OpenKey(sKeyName, False)

        If (hKey Is Nothing) Then
            Return False
        End If

        sValueData = hKey.GetValue(sValueName, "")
        Return True
    End Function

    Public Function GetINT(ByVal sKeyName As String, ByVal sValueName As String, ByRef nValueData As Integer) As Boolean

        If (sKeyName.Length = 0 Or sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey = OpenKey(sKeyName, False)

        If (hKey Is Nothing) Then
            Return False
        End If

        nValueData = hKey.GetValue(sValueName, -1)
        Return True
    End Function

    Public Function GetLONG(ByVal sKeyName As String, ByVal sValueName As String, ByRef lValueData As Long) As Boolean

        If (sKeyName.Length = 0 Or sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey = OpenKey(sKeyName, False)

        If (hKey Is Nothing) Then
            Return False
        End If

        lValueData = hKey.GetValue(sValueName, -1)

        Return True

    End Function

    Public Function GetBOOL(ByVal sKeyName As String, ByVal sValueName As String, ByRef bValueData As Boolean) As Boolean

        Dim nVlaueData As Integer = -1
        bValueData = False

        If (GetINT(sKeyName, sValueName, nVlaueData) = False) Then
            Return False
        End If

        If (nVlaueData = 1) Then
            bValueData = True
        End If

        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    Public Function DeleteSubKey(ByVal sKey As String) As Boolean

        If (sKey.Length = 0) Then
            Return False
        End If

        m_hKey.DeleteSubKeyTree(sKey, False)
        Return True

    End Function

    Public Function DeleteValue(ByVal sKeyRootName As String, ByVal sValueName As String) As Boolean

        If (sValueName.Length = 0) Then
            Return False
        End If

        Dim hKey As RegistryKey
        hKey = OpenKey(sKeyRootName, True)

        If hKey Is Nothing Then
            Return False
        End If

        hKey.DeleteValue(sValueName, False)
        hKey.Close()

        Return True

    End Function

    Public Function EnumSubKeys(ByVal sKeyRootName As String, ByRef objListSubKeys As List(Of String)) As Boolean

        If sKeyRootName.Length = 0 Then
            Return False
        End If

        Dim hKey As RegistryKey
        hKey = OpenKey(sKeyRootName, False)

        If hKey Is Nothing Then
            Return False
        End If

        Dim arrayLogin As String() = hKey.GetSubKeyNames()
        If arrayLogin Is Nothing Then
            Return False
        End If

        Dim nCount As Integer
        For nCount = 0 To arrayLogin.Length - 1
            objListSubKeys.Add(arrayLogin(nCount))
        Next

        hKey.Close()
        Return True

    End Function

    Public Function IsKeyExist(ByVal sSubKeyName As String) As Boolean

        Dim hKey As RegistryKey
        hKey = OpenKey(sSubKeyName, False)

        If hKey Is Nothing Then
            Return False
        End If

        hKey.Close()
        Return True

    End Function

End Class
